import Numeric, arrayfrombuffer, mmap, os, stat, time

# write two input 512-mebibyte files and an output one
blocksize = 1024
filesize = 512 * 1024*1024
buf = Numeric.arange(blocksize, typecode='f')
buf.savespace(1)
loops = filesize / blocksize / buf.itemsize()
zeros = Numeric.zeros(blocksize, 'f')
a, b = open('tmp.a', 'wb'), open('tmp.b', 'wb')
c = open('tmp.c', 'wb')
for i in xrange(loops):
    s = buf.tostring()
    a.write(s)
    b.write(s)
    c.write(zeros.tostring())
    buf += 1024
a.close()
b.close()
c.close()

print "done creating array files."

# now mmap them
def maparray(filename, typecode):
    f = open(filename, 'r+')
    fn = f.fileno()
    m = mmap.mmap(fn, os.fstat(fn)[stat.ST_SIZE])
    return arrayfrombuffer.arrayfrombuffer(m, typecode)

a = maparray('tmp.a', 'f')
b = maparray('tmp.b', 'f')
c = maparray('tmp.c', 'f')

print a.shape, b.shape, c.shape

# now we add them.  We use the three-argument Numeric.add instead
# of just c = a + b to avoid generating a temporary sum array in
# memory.
start = time.time()
Numeric.add(a, b, c)
print "done adding, closing..."
del a, b, c
print "done after %f seconds" % (time.time() - start)
# On my laptop, that reported 668 seconds for (512 * 1024 * 1024)-byte
# arrays.  Which sucks a bit, because it should ideally be about 150
# seconds --- my disk can theoretically read or write about ten
# mebibytes per second --- and it wasn't CPU-bound.  But it actually
# takes 133 seconds, not 50, to read one of those files from beginning
# to end with 'dd', and 163 seconds to write it, which means the
# performance overhead of using mmap() on three files instead of just
# read() or write() on one is around 50-60%.
